#include <stdlib.h>
#include "db.h"

static FILE *__fp_db;

void open_database (char *file_name) {

/* Check if the file can be opened */
   if ((__fp_db = fopen(file_name,"r")) == NULL) {
     perror ("Open DB :");
     exit(0);
   }
   return;
}

char * lookup_ip_address (char *host_name) {

   char db_ip_addr[DB_MAX_IP_ADDR_SIZE];
   char db_host_name[DB_MAX_HOST_NAME_SIZE];
   char *ret_ip;

   if (fseek(__fp_db, 0, SEEK_SET) == -1) {
       perror("Fseek DB :");
       exit(0);
   }
   while (fscanf (__fp_db, "%s %s",db_ip_addr, db_host_name) != EOF) {
       db_ip_addr[strlen(db_ip_addr)] = '\0';
       db_host_name[strlen(db_host_name)] = '\0';
       if (strcmp(db_host_name,host_name) == 0) {
          ret_ip = (char *) malloc (strlen(db_ip_addr));
          strcpy(ret_ip,db_ip_addr);
          return ret_ip;
       }
   }

   return NULL;
}
          
   
char * lookup_host_name (char * ip_address) {

   char db_ip_addr[DB_MAX_IP_ADDR_SIZE];
   char db_host_name[DB_MAX_HOST_NAME_SIZE];
   char *ret_hn;

   if (fseek(__fp_db, 0, SEEK_SET) == -1) {
       perror("Fseek DB :");
       exit(0);
   }
   while (fscanf (__fp_db, "%s %s",db_ip_addr, db_host_name) != EOF) {
       db_ip_addr[strlen(db_ip_addr)] = '\0';
       db_host_name[strlen(db_host_name)] = '\0';
       if (strcmp(db_ip_addr,ip_address) == 0) {
          ret_hn = (char *) malloc (strlen(db_host_name));
          strcpy(ret_hn,db_host_name);
          return ret_hn;
       }
   }

   return NULL;
}
          
void close_database (void) {
  fclose(__fp_db);
  return;
}

   
/*
int main (int argc, char **argv)
{
  open_database(argv[1]);
  char *t;
  t = lookup_ip_address("lovejoy.cs.umd.edu");
  printf ("%s\n",t);
  t =lookup_ip_address("sdsds");
  if (t != NULL) printf ("%s \n",t); else printf ("1 Not found\n");
  t = lookup_host_name("124.34.45.1");
  printf ("%s\n",t);
  t =lookup_host_name("sdsds");
  if (t != NULL) printf ("%s \n",t); else printf (" 2 Not found\n");
  return 1;
};
*/
